#ifndef GLOBALPARAMETERS_SEEN
#define GLOBALPARAMETERS_SEEN

#include <iostream>
#include <string>
#include <fstream>

#include "UAP/UAPNode.hpp"

using namespace std;

class globalParameters  
{
  double frequencyDef_;
  double integrationStepDef_;
  int nstepsMaxDef_;
  int nscDef_;

  double frequency_;
  double integrationStep_;
  int nstepsMax_;
  int nsc_;

  int nbParam_;
  string* parametersString_;

  void setDefaultValues()
  {
    frequencyDef_ = 2998.652;
    integrationStepDef_ = 1.0;
    nstepsMaxDef_ = 100000;
    nscDef_ = 10;
  }

  void setDefaults()
  {
    frequency_ = frequencyDef_;
    integrationStep_ = integrationStepDef_;
    nstepsMax_ = nstepsMaxDef_;
    nsc_ = nscDef_;
  }
  
 public:
  
  globalParameters();
  ~globalParameters() 
    {
      if ( parametersString_ != NULL) delete [] parametersString_;
    }
  
  inline void raz() { setDefaults();}
  inline double getFrequency() const {return frequency_;}
  inline double getIntegrationStep() const {return integrationStep_;}
  inline int getNbSteps() const {return nstepsMax_;}  
  inline int getScPeriod() const {return nsc_;}
  string* getParametersString() const;
  void setParametersString(string* param);
  string FileOutputFlow() const;
  void FileInput(ifstream& ifs);

  void InputRep(UAPNode* root);
};
#endif
