#ifndef NOMDELOGICIEL_SEEN
#define NOMDELOGICIEL_SEEN

#include <string> 

using namespace std;

class nomDeLogiciel
{

 public : 
  
  enum Logiciel
  {
    parmela, transport, generator, test, madx, usersprogram, unknownSoftware
  };
  
    
 private :

  Logiciel program_;
  std::string progString_;
   
  static Logiciel fromString( std::string s);
  static std::string toString( Logiciel lg);  
  std::string getWtColor( nomDeLogiciel::Logiciel lg) const;
  
 public : 
 
  nomDeLogiciel();  
  nomDeLogiciel(const string& s);  
  nomDeLogiciel(int val);
  static int getNumberOfSoftwares();
  
  inline std::string getString() const {return progString_;}
  inline nomDeLogiciel::Logiciel getLogiciel() const {return program_;}

  /** Color of the background of the sofware
      Should be a valid Css name as FFEEDD
  */
  inline std::string  getColor() const {return getWtColor(program_);}
  // operators
  nomDeLogiciel& operator= (const nomDeLogiciel& nl);  
  bool operator== (const nomDeLogiciel& nl);  
  bool operator!= (const nomDeLogiciel& nl);
};
#endif
