#ifndef GWT_DIALOG
#define GWT_DIALOG

#include <Wt/WDialog>
#include <Wt/WString>
#include <Wt/WContainerWidget>

using namespace Wt;

/**
 CrÈer une fenÍtre de dialogue et permet de la paramËtres facilement
 @param titre : titre de la fenÍtre
 @param icon : icone ‡ afficher dans le corps de la boite (Warning, Error, Info, Wait, NoIcon)
 @param modal : true si cette fenÍtre doit Ítre bloquante
 @param okButton : true pour fermer cette fenÍtre avec un bouton "ok". false n'affiche aucun bouton
 */

class GWt_dialog : public WDialog
{
    
    public :
    
    enum	iconType { Warning, Error, Info, Wait, NoIcon };
    
    /** Add a dialog with the given container inside
     @param titre: A title displayed on the window title bar
     @param message: The message inside this dialog
     @param container: a valid WContainer
     */
    GWt_dialog(WString titre, WContainerWidget* container, bool modal=false);
    
    /** Add a full dialog window configure with title, message, iconType and button
     @param titre: A title displayed on the window title bar
     @param message: The message inside this dialog
     @param icon: IconType, could be Warning, Error, Info, Wait or NoIcon
     @param modal: true for a blocking dialog, false for a non-blocking dialog
     @param okButton: true if you want a "ok" button at the end
     */
    GWt_dialog(WString titre, WString message, iconType icon=NoIcon, bool modal=false, bool okButton=false);

    /** Add a v content to this widget
    */
    void addVContent(WContainerWidget* wc);
    
    private :
    WVBoxLayout* vDialogLayout_;
};
#endif
