#ifndef GWT_elementCell_SEEN
#define GWT_elementCell_SEEN

#include "GWt_abstractElement.h"

#include <iostream>
#include <string>
#include <sstream>

using namespace Wt;
using namespace std;

class GWt_elementCell : public GWt_abstractElement
{
  WLineEdit* lenghtElemEdit_; // cm
  WLineEdit* apertureEdit_; // cm
  WLineEdit* initialPhaseEdit_; // degres
  WLineEdit* phaseStepMaxEdit_;   // degres
  WLineEdit* acceleratingFieldEdit_; // MV/m
  WLineEdit* acceleratingShapeFileEdit_; // string
  WLineEdit* focusingMagFileEdit_; // string
  WLineEdit* offsetMagEdit_; // cm
  WLineEdit* scaleFactorEdit_;
      
 public :
    
  GWt_elementCell() {;}
  GWt_elementCell(GWt_elementLigneFaisceau* );
  ~GWt_elementCell() {;}
 
  virtual void dialogDone(WDialog::DialogCode code);
    
  inline string getMimeType() {return "htdocs/cell.jpg"; }
  inline string getSmallImageURL() {return "htdocs/cell.jpg"; }
  inline string getBigImageURL() {return "htdocs/cell.jpg"; }
  inline string getName() {return "cell"; }
  
 private :

  void initilializeDialog();
  
};
#endif
