#include "GWt_draggableImage.h"

#include <Wt/WCssDecorationStyle>


GWt_draggableImage::GWt_draggableImage(
                                       const WLink & imageLink,
                                       const WString & altText,
                                       WContainerWidget * parent):
WImage(imageLink,altText,parent)
{
    init();
}


GWt_draggableImage::GWt_draggableImage(
                                       const WLink & imageLink,
                                       WContainerWidget * parent):
WImage(imageLink,"Image PSPA",parent)
{
    init();
}


GWt_draggableImage::~GWt_draggableImage()
{
}


void GWt_draggableImage::init(){
    changeCursorOnMouseOver_ = true;
    
    //  setMouseOverDelay(100);
    mouseWentOver().connect(this, &GWt_draggableImage::mouseOver);
    mouseWentUp().connect(this, &GWt_draggableImage::mouseUp);
    mouseWentDown().connect(this, &GWt_draggableImage::mouseDown);
    mouseWentOut().connect(this, &GWt_draggableImage::mouseOut);
    mouseDragged().connect(this, &GWt_draggableImage::mouseIsDragged);
    setStyleClass("draggableIcon");

}


void GWt_draggableImage::setChangeCursorOnMouseOver(bool change){
    changeCursorOnMouseOver_ = change;
}


void GWt_draggableImage::mouseOver(const WMouseEvent& e)
{
    if (changeCursorOnMouseOver_) {
        decorationStyle().setCursor(OpenHandCursor);
    } else {
        decorationStyle().setCursor(ArrowCursor);
    }
}

void GWt_draggableImage::mouseOut(const WMouseEvent& e)
{
    decorationStyle().setCursor(ArrowCursor);
}

void GWt_draggableImage::mouseIsDragged(const WMouseEvent& e)
{
}

void GWt_draggableImage::mouseUp(const WMouseEvent& e)
{
}

void GWt_draggableImage::mouseDown(const WMouseEvent& e)
{
}
