
#include "GWt_elementMpole.h"
#include "mixedTools.h"

#include <Wt/WText>
#include <Wt/WLineEdit>
#include <Wt/WBreak>
#include <Wt/WDialog>
#include <Wt/WPushButton>

GWt_elementMpole::GWt_elementMpole(GWt_elementLigneFaisceau* elm) : GWt_abstractElement(new elementMultipole())
{
  elementLigneFaiseauContainer_ = elm;
  initialize();
}

void GWt_elementMpole::initilializeDialog() 
{
  string* param = beginDialog();
  new WText("order : ",dialog_->contents());
  orderEdit_ = new WLineEdit(param->c_str(),dialog_->contents());
  new WBreak(dialog_->contents());
  new WText("component (m^-n) : ",dialog_->contents());
  componentEdit_ = new WLineEdit((++param)->c_str(),dialog_->contents());
  new WBreak(dialog_->contents());

  WPushButton *annule= new WPushButton("cancel",dialog_->contents()); 
  annule->clicked().connect(dialog_, &Wt::WDialog::reject);
  WPushButton *submit= new WPushButton("OK",dialog_->contents());
  submit->clicked().connect(dialog_, &Wt::WDialog::accept);
  dialog_->finished().connect(this, &GWt_elementMpole::dialogDone);
}

void GWt_elementMpole::dialogDone(WDialog::DialogCode code)
{
  if (code != Wt::WDialog::Accepted) return;

  unsigned nbParam = abstractElement_->getNbParams();
  string* envoi = new string[nbParam+1];
  int compteur = -1;

  envoi[++compteur] = mixedTools::intToString(nbParam);
  envoi[++compteur] = labelEdit_->text().toUTF8();
  envoi[++compteur] = orderEdit_->text().toUTF8();
  envoi[++compteur] = componentEdit_->text().toUTF8();
  if ( compteur !=  (int)nbParam ) {
    cerr << " GWt_elementMpole::dialogDone() : pb dans le nb de parametres, compteur = " << compteur << " nbParam= " << nbParam << endl;
    return;
  }

  abstractElement_->setParametersString(envoi);
  updateLabelAndToolTipWidget();
  delete [] envoi;
}

WImage* GWt_elementMpole::getImage() {
  return image_;
}
