
#include "GWt_elementSnapshot.h"
#include "mixedTools.h"

#include <Wt/WText>
#include <Wt/WBreak>
#include <Wt/WLineEdit>
#include <Wt/WDialog>
#include <Wt/WPushButton>

GWt_elementSnapshot::GWt_elementSnapshot(GWt_elementLigneFaisceau* elemLigne, int num) : GWt_abstractElement(new elementSnapshot(num))
{
  elementLigneFaiseauContainer_ = elemLigne;
  initialize();
}

void GWt_elementSnapshot::initilializeDialog() 
{
  string* param = beginDialog();

  new WText("name of user's program : ",dialog_->contents());
  programFile_ = new WLineEdit(param->c_str(),dialog_->contents());
  new WBreak(dialog_->contents());


  new WText("name of input beam file, output from pspa : ",dialog_->contents());
  inputBeamFile_ = new WLineEdit( (++param)->c_str(),dialog_->contents());
  new WBreak(dialog_->contents());

  new WText("name of output beam file (input for pspa) : ",dialog_->contents());
  outputBeamFile_ = new WLineEdit( (++param)->c_str(),dialog_->contents());
  new WBreak(dialog_->contents());

  WPushButton *annule= new WPushButton("cancel",dialog_->contents()); 
  annule->clicked().connect(dialog_,&Wt::WDialog::reject);
  WPushButton *submit= new WPushButton("OK",dialog_->contents());
  submit->clicked().connect(dialog_,&Wt::WDialog::accept);
  dialog_->finished().connect(this, &GWt_elementSnapshot::dialogDone);
}

void GWt_elementSnapshot::dialogDone(WDialog::DialogCode code)
{
  if (code != Wt::WDialog::Accepted) return;
  
  unsigned nbParam = abstractElement_->getNbParams();
  string* envoi = new string[nbParam+1];
  int compteur = -1;
  
  envoi[++compteur] = mixedTools::intToString(nbParam);
  envoi[++compteur] = labelEdit_->text().toUTF8();
  envoi[++compteur] = programFile_->text().toUTF8();
  envoi[++compteur] = inputBeamFile_->text().toUTF8();
  envoi[++compteur] = outputBeamFile_->text().toUTF8();


  if ( compteur !=  (int)nbParam ) {
    cerr << " GWt_elementSnapshot::dialogDone() : pb dans le nb de parametres, compteur = " << compteur << " nbParam= " << nbParam << endl;
    return;
  }

  abstractElement_->setParametersString(envoi);
  delete [] envoi;
}
